<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TerminateModem StructType
 * @subpackage Structs
 */
class TerminateModem extends AbstractStructBase
{
    /**
     * The modemSerial
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $modemSerial;
    /**
     * Constructor method for TerminateModem
     * @uses TerminateModem::setModemSerial()
     * @param string $modemSerial
     */
    public function __construct($modemSerial = null)
    {
        $this
            ->setModemSerial($modemSerial);
    }
    /**
     * Get modemSerial value
     * @return string|null
     */
    public function getModemSerial()
    {
        return $this->modemSerial;
    }
    /**
     * Set modemSerial value
     * @param string $modemSerial
     * @return \CustomerManagement\StructType\TerminateModem
     */
    public function setModemSerial($modemSerial = null)
    {
        // validation for constraint: string
        if (!is_null($modemSerial) && !is_string($modemSerial)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($modemSerial, true), gettype($modemSerial)), __LINE__);
        }
        $this->modemSerial = $modemSerial;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\StructType\TerminateModem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
